#!/usr/bin/perl
#
# NLMDiff
#
# Releases notes :
# - 1.0, 7jun2002 : Initial release
# - 1.1, 10jun2002 : added "Text to match field"
# - 1.2, 7jan2003 : bug correction (if not using match field, result was always empty)
#
# This cgi-script scan loaded netware NLMs using SNMP on several Netware servers
# and will generate a web page showing the NLMs for each servers
# and a matrix showing the difference.
#
# This script should be installed on a cgi-bin directectory of your web server.
# Net::SNMP needs to be present in you Perl installation.
#
# SNMP must be configured on your Netware servers. Tested with Netware 5.1SP3
#
# For example, you want to check wether all of your server have same hardware driver :
# simply put 'HAM LAN DSK' into the 'Text to match' field and select all of your servers.
#
# This script is free.
#
# (CopyRight) Jean-Francois.Burdet@adm.unige.ch , 7 june 2002
#
#
######### CONFIG STARTS HERE ##########

# Config file syntax :
# hostname snmp_community_read_password
# Example :
# srv1nw51.yourdomain.com lamepassword
# srv2nw51.yourdomain.com guessme

my $cfg_file = "/home/bootstat/conf/nlmdiff.cfg"; # You probably wants to change this !

######### CONFIG ENDS HERE ############

use Net::SNMP;
use CGI;

my $script_version = "NLMDiff 1.2";
my $cp_right = "This software is free - (c) JF Burdet, june 2002 - ";
$cp_right .= "<a href=\"http://www.unige.ch/~burdetj/nlmdiff\">NLMDiff home page</a>";

$query = new CGI;

select(STDERR); $|=1; #unbuffer
select(STDOUT); $|=1; #unbuffer
print &CGI::PrintHeader;
print "<HTML>\n<HEADER>\n<TITLE>$script_version</TITLE><BODY>\n";
print "<h2>$script_version</h2>";

if ($query->param('host_list') eq '') {

	print "Here are the host read from the following config file :<br>\n";
	print "$cfg_file<br>";
	open(cfgfile, '<', $cfg_file) ||  print "<b>Cannot open cfg file ! Please check your configuration</b><br><br>";;

	print "<br>Choose the hosts to be compared (use shift ou ctrl make multi selection) : <br><br>";

	my @hostlist;
	my %labellist;
	while (<cfgfile>) {
	        if ($_=~m/\s*#/i) {next;}  # Skipping comment lines beginning with '#'
		my ($hostname, $community) = split(" ", $_);
		push(@hostlist,$hostname."#".$community);
		$labellist{$hostname."#".$community}=$hostname;
	} 
	close(cfgfile);
			

	print $query->startform($method,$action,$encoding);

	print $query->scrolling_list(-name=>'host_list',
                              -values=>\@hostlist,
			      -multiple=>'true',
			      -labels=>\%labellist,
                              -size=>10);
	print "<br>\n";
	print print $query->checkbox(-name=>'checkbox_nlmlist',
	           -label=>"Show full NLM list");
	print "<br><br>Text to match :\n";
	print $query->textarea(-name=>'txtgrp',
                    -size=>50,
                    -maxlength=>80);

	print "<br><br>".$query->submit(-name=>'Do report');
	print $query->endform;
	print "<br>$cp_right\n";
	print "</BODY></HTML>";
} else {

	my @grp = split(/[\t\n\r\f ]/, $query->param('txtgrp')); #grep on any space like char
	
 	my $dogrp = ($query->param('txtgrp') ne '');	
	print "<p>\n\n\n";
	print "Please wait while collecting information and building page.<br>\n";
	print "Collecting SNMP information for : <br>\n";
	print "<ul>\n";
	my $oidNlmTable = "1.3.6.1.4.1.23.2.28.9.1.1";
	my ($oidNlmName, $oidNlmMajorRev, $oidNlmMinorRev, $oidNlmRevision, $oidNlmDate) = 
		 ($oidNlmTable.".2",$oidNlmTable.".7",$oidNlmTable.".8",$oidNlmTable.".9",$oidNlmTable.".10");

	my %mainHash;
	my @host_to_check = $query->param('host_list');

	# 1st, we gather information and store it into a hash.
	foreach (@host_to_check) {
		my ($hostname, $community) = split("#", $_);
		print "<li>$hostname</li>\n";
		my ($session,$error) = Net::SNMP->session( hostname  => $hostname,community => $community );
		if (!defined($session)) {print "Snmp session failed<br>";} else {
			$session->timeout("1.0");
			my ($n_name, $n_major, $n_minor, $n_rev, $n_date);
			$n_name = $session->get_table($oidNlmName);
			$n_major = $session->get_table($oidNlmMajorRev);
			$n_minor = $session->get_table($oidNlmMinorRev);
			$n_rev = $session->get_table($oidNlmRevision);
			$n_date = $session->get_table($oidNlmDate);
			if (!defined($n_name) || !defined($n_major) || !defined($n_minor) || !defined($n_rev) 
				|| !defined($n_date)) {print "Snmp get_table failed<br>"};
			foreach $key (sort keys(%$n_name)) {
				$key =~ /$oidNlmName\.(.*)$/;
				my $name = $$n_name{"$oidNlmName.$1"};
			my $rev = $$n_major{"$oidNlmMajorRev.$1"}.".".$$n_minor{"$oidNlmMinorRev.$1"}.".".$$n_rev{"$oidNlmRevision.$1"};
				$$n_date{"$oidNlmDate.$1"} =~ /0x(.{4})(.{2})(.{2})(.*)/;  # Format DateAndTime from RFC 1514.MIB
				$rev = $rev." ".hex($1)."/".hex($2)."/".hex($3);
				$mainHash{$hostname}{$name}=$rev;
			}
			$session->close();
		}
	}
	print "</ul>\n";

	if ($dogrp) {print "Showing only line matching : ".$query->param('txtgrp')."<br>";}
	
	# 2nd we show NLM for each servers
	my $servers1;
	my $nlms1;
	print "<h2>NLM for choosen servers</h2><ul>";
	foreach $servers1 (sort keys %mainHash) {
		print "<li>$servers1 : ".keys(%{$mainHash{$servers1}})." nlms</li>";
		print "<ul>";
		if ($query->param('checkbox_nlmlist') eq 'on') {
			foreach $nlms1 (sort keys %{$mainHash{$servers1}}) {
				if ($dogrp) {
					foreach (@grp) {
						if ($nlms1 =~ m/$_/i) {
							print "<li>$nlms1 Rev : $mainHash{$servers1}{$nlms1}</li>";
						}
					}
				} else {
					print "<li>$nlms1 Rev : $mainHash{$servers1}{$nlms1}</li>";
				}
			}
		}
		print "</ul>";
	}
	print "</ul>";

	# 3nd we show matrix showing differences between servers
	my $servers2;
	my $nlms2;
	print "<h2>NLM matrix comparison</h2>";
	print "<small><small>";
	print "<table border=1>";
	print "<tr><td></td>";
	foreach $servers1 (sort keys %mainHash) {
		print "<td>$servers1</td>";
	}
	print "</tr>";
	foreach $servers1 (sort keys %mainHash) {
		print "<tr>";
		print "<td>$servers1</td>";
		foreach $servers2 (sort keys %mainHash) {
			print "<td><small><small>";
			foreach $nlms1 (sort keys %{$mainHash{$servers1}}) {
				if (exists($mainHash{$servers2}{$nlms1})) {
					if ($mainHash{$servers1}{$nlms1} ne $mainHash{$servers2}{$nlms1}) {
						if ($dogrp) {
						       foreach (@grp) {
					                    if ($nlms1 =~ m/$_/i) {
								print "# $nlms1 : $mainHash{$servers1}{$nlms1} <> $mainHash{$servers2}{$nlms1}<br>\n";
								}
							}
						} else {
							print "# $nlms1 : $mainHash{$servers1}{$nlms1} <> $mainHash{$servers2}{$nlms1}<br>\n";
						}
					}
				} else {
					if ($dogrp) {
						foreach (@grp) {
							if ($nlms1 =~ m/$_/i) {
								print "+ $nlms1<br>\n";
							}
						}
					}
				}
			}

			foreach $nlms1 (sort keys %{$mainHash{$servers2}}) {
	                        if (!exists($mainHash{$servers1}{$nlms1})) {
					if ($dogrp) {
						foreach (@grp) {
							if ($nlms1 =~ m/$_/i) {
       	                         				print "- $nlms1<br>\n";
							}
						}
					}
                	        }
			}
			print "</small></small></td>";
		}
		print "<tr>";
	}
	print "</table>";
	print "</small></small>";
	print "<br>$cp_right\n";
	print "</BODY></HTML>";

}
